foundation-0.0.17: Alternative prelude with batteries and no dependencies

Safe Haskell | None
Language | Haskell2010

Foundation.Monad.Except

# Documentation

newtype ExceptT e m a Source #

Constructors

ExceptT |

Fields

- runExceptT :: m (Either e a)

Instances

MonadTrans (ExceptT e) Source # |
Methods lift :: Monad m => m a -> ExceptT e m a Source #
Monad m => Monad (ExceptT e m) Source # |
Methods (>>=) :: ExceptT e m a -> (a -> ExceptT e m b) -> ExceptT e m b # (>>) :: ExceptT e m a -> ExceptT e m b -> ExceptT e m b # return :: a -> ExceptT e m a # fail :: String -> ExceptT e m a #
Functor m => Functor (ExceptT e m) Source # |
Methods fmap :: (a -> b) -> ExceptT e m a -> ExceptT e m b # (<$) :: a -> ExceptT e m b -> ExceptT e m a #
(Functor m, Monad m) => Applicative (ExceptT e m) Source # |
Methods pure :: a -> ExceptT e m a # (<*>) :: ExceptT e m (a -> b) -> ExceptT e m a -> ExceptT e m b # (*>) :: ExceptT e m a -> ExceptT e m b -> ExceptT e m b # (<*) :: ExceptT e m a -> ExceptT e m b -> ExceptT e m a #
MonadIO m => MonadIO (ExceptT e m) Source # |
Methods liftIO :: IO a -> ExceptT e m a #
Monad m => MonadFailure (ExceptT e m) Source # |
Associated Types type Failure (ExceptT e m :: * -> *) :: * # Methods mFail :: Failure (ExceptT e m) -> ExceptT e m () #
MonadReader m => MonadReader (ExceptT e m) Source # |
Associated Types type ReaderContext (ExceptT e m :: * -> *) :: * Source # Methods ask :: ExceptT e m (ReaderContext (ExceptT e m)) Source #
type Failure (ExceptT e m) Source # |
type Failure (ExceptT e m) = e
type ReaderContext (ExceptT e m) Source # |
type ReaderContext (ExceptT e m) = ReaderContext m